import '@angular/compiler';
// import 'reflect-metadata';
import { ɵReflectionCapabilities as ReflectionCapabilities, } from '@angular/core';
import { isComponent, isNgModule } from './ng-type-guards.mjs';
export { reflectComponentType } from '@angular/core';
export const reflectionCapabilities = new ReflectionCapabilities();
function getDecorators(type) {
    return [...reflectionCapabilities.annotations(type)].reverse();
}
export function getComponentDecoratorData(component) {
    return getDecorators(component).find((x) => x.ngMetadataName === 'Component');
}
export function getNgModuleDecoratorData(ngModule) {
    return getDecorators(ngModule).find((x) => x.ngMetadataName === 'NgModule');
}
export function isComponentExportedFromNgModule({ component, ngModule, }) {
    var _a;
    if (!isNgModule(ngModule)) {
        throw new Error('ngModule is not a NgModule');
    }
    if (!isComponent(component)) {
        throw new Error('component is not a Component');
    }
    const ngModuleDecorator = getNgModuleDecoratorData(ngModule);
    if (!ngModuleDecorator) {
        throw new Error('ngModule is not a NgModule');
    }
    return (_a = ngModuleDecorator.exports) === null || _a === void 0 ? void 0 : _a.some((x) => x === component);
}
//# sourceMappingURL=ng-utils.mjs.map