"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _KnapsackAngularRenderer_instances, _KnapsackAngularRenderer_customNgModulePath, _KnapsackAngularRenderer_wrapperComponentPath, _KnapsackAngularRenderer_resolveImportPath;
Object.defineProperty(exports, "__esModule", { value: true });
exports.KnapsackAngularRenderer = void 0;
const app_1 = require("@knapsack/app");
const renderer_webpack_base_1 = require("@knapsack/renderer-webpack-base");
const file_utils_1 = require("@knapsack/file-utils");
const types_1 = require("@knapsack/types");
const renderers_1 = require("@knapsack/app/renderers");
const path_1 = require("path");
const types_2 = require("./types");
const { pkg } = (0, file_utils_1.findUpPkgJson)(__dirname);
const rendererId = types_1.rendererIds.angular;
class KnapsackAngularRenderer extends renderer_webpack_base_1.RendererWebpackBase {
    constructor({ customNgModulePath, wrapperComponentPath, pkgPathAliases, codeSrcs, ...extraParams } = {}) {
        super({
            id: rendererId,
            language: 'ts',
            codeSrcsUserConfig: codeSrcs,
            /** These are pulled into the Webpack entry, so are therefore available to the client/browser-side code */
            extraScripts: [
                // this is the code in `./client/init.mts`
                '@knapsack/renderer-angular/client',
            ],
            webpackConfig: {
                resolve: {
                    alias: pkgPathAliases,
                },
            },
        });
        _KnapsackAngularRenderer_instances.add(this);
        _KnapsackAngularRenderer_customNgModulePath.set(this, void 0);
        _KnapsackAngularRenderer_wrapperComponentPath.set(this, void 0);
        this.setConfig = (opt) => {
            super.setConfig(opt);
            const configuredImports = {
                ...(__classPrivateFieldGet(this, _KnapsackAngularRenderer_customNgModulePath, "f") && {
                    CustomNgModule: {
                        exportName: 'CustomNgModule',
                        isDefaultExport: true,
                        path: __classPrivateFieldGet(this, _KnapsackAngularRenderer_instances, "m", _KnapsackAngularRenderer_resolveImportPath).call(this, __classPrivateFieldGet(this, _KnapsackAngularRenderer_customNgModulePath, "f"), 'customNgModulePath'),
                    },
                }),
                ...(__classPrivateFieldGet(this, _KnapsackAngularRenderer_wrapperComponentPath, "f") && {
                    WrapperComponent: {
                        exportName: 'WrapperComponent',
                        isDefaultExport: true,
                        path: __classPrivateFieldGet(this, _KnapsackAngularRenderer_instances, "m", _KnapsackAngularRenderer_resolveImportPath).call(this, __classPrivateFieldGet(this, _KnapsackAngularRenderer_wrapperComponentPath, "f"), 'wrapperComponentPath'),
                    },
                }),
            };
            if (Object.keys(configuredImports).length > 0) {
                this.registerExtraJsImports(configuredImports);
            }
        };
        this.init = async (opt) => {
            await super.init(opt);
            const { exists, absolutePath } = await (0, file_utils_1.resolvePath)({
                path: '@angular/core/package.json',
                resolveFromDir: this.userConfigDir,
            });
            if (!exists) {
                throw new Error(`The package "@angular/core" cannot be resolved`);
            }
            const { version: ngVersion } = await (0, file_utils_1.readJSON)(absolutePath);
            const majorVersion = parseInt(ngVersion.split('.')[0], 10);
            if (majorVersion < 17) {
                // Consider listing every package in `peerDependencies` in the error message or linking usage of a tool like https://www.npmjs.com/package/install-peerdeps
                this.log.error(`Knapsack Angular Renderer requires Angular 17 or later, but ${ngVersion} was found. Alternatively you can stay on version 4.67.5 of "@knapsack/*" packages to use legacy functionality (though the Angular Renderer has greatly improved after that version)`);
                process.exit(1);
            }
        };
        this.watch = async () => {
            super.watch();
            const { clearImporterCache } = await import('./analyze/index.mjs');
            app_1.knapsackEvents.onPatternTemplateChanged(() => clearImporterCache());
        };
        this.render = async (opt) => {
            const { usage: rawUsage, importMap } = await this.getUsageAndImports({
                ...opt,
                importMap: new Map(),
            });
            const usage = await (0, file_utils_1.formatCode)({
                contents: rawUsage,
                // just used for figuring out the code language
                path: 'x.html',
            });
            const meta = {
                demo: opt.demo,
                template: rawUsage,
                hasWrapper: !!__classPrivateFieldGet(this, _KnapsackAngularRenderer_wrapperComponentPath, "f"),
                neededImportsByCodeSrcId: (0, renderer_webpack_base_1.convertImportMapToNeededImportsByCodeSrcId)(importMap),
            };
            // ${rawUsage}
            const code = /* html */ `
    <div id="render-root" class="knapsack-pattern-direct-parent" data-dev-note="Knapsack Angular Template Wrapper">
      <ks-app-root> </ks-app-root>
      <script type="application/json" id="${types_2.rendererMetaScriptTagId}">${JSON.stringify(meta)}</script>
      ${renderer_webpack_base_1.RendererWebpackBase.createHtmlTagsForAssetPaths({
                assets: this.getWebpackAssetPaths(),
                scriptTagsAreAsync: true,
            })}
    </div>
    `;
            return {
                ok: true,
                html: await (0, file_utils_1.formatCode)({
                    contents: code,
                    path: 'x.html',
                }),
                usage: (0, types_1.isDemoWithData)(opt.demo)
                    ? usage
                    : // @todo template demo usage should show original code https://linear.app/knapsack/issue/KSP-5401/handle-template-demo-usage
                        '',
            };
        };
        this.getUsageAndImports = async ({ demo, importMap, state, }) => {
            if (!demo) {
                throw new Error(`Demo missing when rendering `);
            }
            const { computesTemplateFromComponent, importComponent, applySlotContent, analyzeComponent, } = await import('./analyze/index.mjs');
            switch (demo.type) {
                case 'data-w-template-info':
                case 'data': {
                    const { codeSrcPath, exportName } = this.normalizeDemo({
                        demo,
                        state,
                    });
                    await this.addUniqueValueToImportMap({
                        importMap,
                        path: codeSrcPath,
                        alias: exportName,
                    });
                    const { props, slots, slotsOptionsComputed } = demo.data;
                    const { type } = (0, file_utils_1.getPathType)(codeSrcPath);
                    if (type !== 'package' && type !== 'package-sub-path') {
                        const msg = `Angular Renderer only supports "package" type paths. This was used: ${codeSrcPath}, please build the package using ng-packagr then use the NPM package path here.`;
                        // shows in the console
                        this.log.warn(msg);
                        // shows in the UI's iFrame
                        return { usage: msg, importMap };
                    }
                    const component = await importComponent({
                        path: codeSrcPath,
                        alias: exportName,
                        pkgPathAliases: this.pkgPathAliases,
                    });
                    const { ngContentSelectors: ngSelectors, ngTemplateOutlets } = analyzeComponent(component);
                    const slotsUsages = await Promise.all(Object.entries(slots || {}).map(async ([slotName, slotDatas]) => {
                        // start looping over content in this single slot
                        const slotUsages = await Promise.all(slotDatas.map(async (slotData) => {
                            switch (slotData.type) {
                                case 'text':
                                    return { usage: slotData.text };
                                case 'template-reference':
                                    throw new Error(`template-reference slot type is not implemented`);
                                case 'template-demo': {
                                    const { demo: slottedDemo } = slotData;
                                    if (!slottedDemo)
                                        return { usage: '' };
                                    const { usage: slottedUsage } = await this.getUsageAndImports({
                                        demo: slottedDemo,
                                        state,
                                        importMap,
                                    });
                                    return {
                                        usage: slottedUsage || '',
                                    };
                                }
                                default: {
                                    const _exhaustiveCheck = slotData;
                                }
                            }
                        }));
                        // done looping over content in this single slot
                        const innerContent = slotUsages
                            .filter(({ usage }) => !!usage)
                            .map(({ usage }) => usage)
                            .join('\n');
                        const slotOptionsComputed = slotsOptionsComputed === null || slotsOptionsComputed === void 0 ? void 0 : slotsOptionsComputed[slotName];
                        const { openTag, closeTag } = (0, renderers_1.createSlotOptionsHtmlTags)({
                            slotOptionsComputed,
                            classAttributeName: 'class',
                            stylesValueType: 'string',
                        });
                        return {
                            slotName,
                            innerContent: openTag && closeTag && innerContent
                                ? [openTag, innerContent, closeTag].join('\n')
                                : innerContent,
                        };
                    }));
                    const usage = await computesTemplateFromComponent({
                        component,
                        initialProps: props,
                        innerTemplate: slotsUsages
                            .filter(({ innerContent }) => innerContent)
                            .map(({ innerContent, slotName }) => {
                            return applySlotContent({
                                slotName,
                                content: innerContent,
                                ngSelectors,
                                ngTemplateOutlets,
                            });
                        })
                            .join('\n'),
                    });
                    return { usage, importMap };
                }
                case 'template': {
                    const { templateInfo: { path, alias }, } = demo;
                    const pathInfo = (0, file_utils_1.getPathType)(path);
                    if (pathInfo.type !== 'package' &&
                        pathInfo.type !== 'package-sub-path') {
                        const msg = `Angular Renderer only supports "package" type paths. This was used: ${path}, please build the package using ng-packagr then use the NPM package path here.`;
                        // shows in the console
                        this.log.warn(msg);
                        // shows in the UI's iFrame
                        return { usage: msg, importMap };
                    }
                    await this.addUniqueValueToImportMap({
                        importMap,
                        path: pathInfo.path,
                        alias,
                    });
                    const component = await importComponent({
                        path,
                        alias,
                        resolveFrom: this.userConfigDir,
                        pkgPathAliases: this.pkgPathAliases,
                    });
                    const usage = await computesTemplateFromComponent({
                        component,
                        initialProps: {},
                        innerTemplate: '',
                    });
                    return {
                        usage,
                        importMap,
                    };
                }
                default: {
                    const _exhaustiveCheck = demo;
                }
            }
        };
        this.getDiscovery = async () => {
            const { getComponentNamesFromPkg } = await import('./analyze/index.mjs');
            const results = await Promise.all(this.getCodeSrcs().map(async (codeSrc) => {
                try {
                    const componentNames = await getComponentNamesFromPkg({
                        path: codeSrc.path,
                        resolveFrom: this.dataDir,
                        pkgPathAliases: this.pkgPathAliases,
                    });
                    return {
                        path: codeSrc.path,
                        componentNames,
                    };
                }
                catch (e) {
                    this.log.warn(`Could not get import names for "${codeSrc.path}": ${e.message}`, null, this.logPrefix);
                    return {
                        path: codeSrc.path,
                        componentNames: [],
                    };
                }
            }));
            return {
                rendererId: this.id,
                meta: this.getMeta(),
                codeSrcsByPath: Object.fromEntries(this.codeSrcs.entries()),
                templates: results.flatMap(({ path, componentNames }) => componentNames.map((exportName) => (0, types_1.addIdToTemplateInfo)({
                    rendererId: this.id,
                    codeSrcPath: path,
                    exportName,
                }))),
            };
        };
        this.getTemplateSuggestions = async ({ newPath, state, }) => {
            const { getComponentNamesFromPkg } = await import('./analyze/index.mjs');
            // Deduplicate suggestions using Map with stringified path/alias as keys.
            // Map values are suggestion objects, Array.from(map.values()) returns deduplicated array.
            const usedSuggestions = Array.from(new Map(Object.values(state.patterns).reduce((acc, { templateDemos, templates }) => {
                templates.forEach(({ path, alias, templateLanguageId }) => {
                    if (templateLanguageId !== this.id)
                        return;
                    acc.push([JSON.stringify({ path, alias }), { path, alias }]);
                });
                templateDemos.forEach(({ templateInfo: { path, alias }, templateLanguageId }) => {
                    if (templateLanguageId !== this.id)
                        return;
                    acc.push([JSON.stringify({ path, alias }), { path, alias }]);
                });
                return acc;
            }, [])).values());
            const codeSrcs = new Set(this.getCodeSrcs().map(({ path }) => path));
            const allPaths = [
                ...new Set([
                    ...Object.keys(this.pkgPathAliases || {}),
                    ...codeSrcs,
                    newPath,
                ]),
            ];
            const allSuggestions = await Promise.all(allPaths.map(async (path) => {
                if (!path)
                    return [];
                try {
                    const componentNames = await getComponentNamesFromPkg({
                        path,
                        resolveFrom: this.dataDir,
                        pkgPathAliases: this.pkgPathAliases,
                    });
                    return componentNames.map((name) => ({
                        alias: name,
                        path,
                    }));
                }
                catch (e) {
                    // only want this showing with verbose since template suggestions are not critical
                    this.log.verbose(`Error getting import names for ${path}: ${e.message}`, null, this.logPrefix);
                    return [];
                }
            })).then((results) => {
                // sadly `Promise.all` & `.flatMap` just don't work, so this:
                return results.flat();
            });
            const suggestions = allSuggestions.filter((s) => {
                return !usedSuggestions.find((us) => us.alias === s.alias && us.path === s.path);
            });
            const connectedSuggestions = usedSuggestions.map((s) => ({
                ...s,
                connected: true,
            }));
            return {
                suggestions: [...suggestions, ...connectedSuggestions],
            };
        };
        this.inspect = async ({ codeSrcPath, exportName }) => {
            try {
                const { inferSpec } = await import('./analyze/index.mjs');
                const { ksTemplateSpec: spec } = await inferSpec({
                    path: codeSrcPath,
                    namedExport: exportName,
                    resolveFrom: this.userConfigDir,
                    pkgPathAliases: this.pkgPathAliases,
                });
                return {
                    type: 'success',
                    spec,
                };
            }
            catch (e) {
                this.log.error(e, {
                    codeSrcPath,
                    exportName,
                });
                return {
                    type: 'error.unknown',
                    message: e.message,
                };
            }
        };
        this.getMeta = () => ({
            id: this.id,
            title: 'Angular',
            aliasUse: 'required',
            aliasTitle: 'Named Export',
            aliasDescription: 'JS export name',
            enableDataDemos: true,
            enableTemplateDemos: true,
            hasSlotsSupport: true,
            hasSlotOptionsSupport: true,
            aliasIsJsNamedExport: true,
            version: pkg.version,
            hasInferSpecSupport: true,
            hasTemplateSuggestionsSupport: true,
            prototypingTemplate: {
                path: '@knapsack/renderer-angular/prototyping-template',
                alias: 'PrototypingTemplateComponent',
                spec: {
                    isInferred: false,
                    props: {
                        type: 'object',
                        properties: {},
                    },
                    slots: {
                        default: { title: 'Default' },
                    },
                },
            },
        });
        __classPrivateFieldSet(this, _KnapsackAngularRenderer_customNgModulePath, customNgModulePath, "f");
        __classPrivateFieldSet(this, _KnapsackAngularRenderer_wrapperComponentPath, wrapperComponentPath, "f");
        const angularJsonPath = 
        // @ts-expect-error this used to be a type on our constructor
        extraParams.angularJsonPath || file_utils_1.findUp.sync('angular.json');
        if (typeof angularJsonPath === 'string') {
            const ngJson = (0, file_utils_1.readJSONSync)(angularJsonPath);
            if (ngJson.projects['knapsack-renderer-angular-app']) {
                const angularJsonDirPath = (0, path_1.dirname)(angularJsonPath);
                const ngAppRoot = (0, path_1.join)(angularJsonDirPath, ngJson.projects['knapsack-renderer-angular-app'].root);
                this.log.error([
                    `The Knapsack Angular Renderer has improved and no longer needs a project "knapsack-renderer-angular-app" in angular.json`,
                    `Please remove it from angular.json along with the code it references`,
                    `angular.json path: ${angularJsonPath}`,
                    `App Code to Remove: ${ngAppRoot}`,
                ].join('\n'));
                process.exit(1);
            }
        }
        const extraParamNames = Object.keys(extraParams);
        if (extraParamNames.length) {
            this.log.error([
                `KnapsackAngularRenderer does not accept the following parameters:`,
                extraParamNames.join(', '),
                'Please remove them from the constructor call in knapsack.config.cjs',
            ].join('\n'));
            process.exit(1);
        }
    }
}
exports.KnapsackAngularRenderer = KnapsackAngularRenderer;
_KnapsackAngularRenderer_customNgModulePath = new WeakMap(), _KnapsackAngularRenderer_wrapperComponentPath = new WeakMap(), _KnapsackAngularRenderer_instances = new WeakSet(), _KnapsackAngularRenderer_resolveImportPath = function _KnapsackAngularRenderer_resolveImportPath(path, pathType) {
    const { type, exists, absolutePath } = this.resolvePathSync({
        path,
        resolveFromDir: this.userConfigDir,
    });
    if (!exists) {
        throw new Error(`Angular: ${pathType} cannot be resolved: ${path}`);
    }
    const resolvedPath = type === 'package' ? path : absolutePath;
    if (pathType === 'customNgModulePath') {
        __classPrivateFieldSet(this, _KnapsackAngularRenderer_customNgModulePath, resolvedPath, "f");
    }
    else {
        __classPrivateFieldSet(this, _KnapsackAngularRenderer_wrapperComponentPath, resolvedPath, "f");
    }
    return resolvedPath;
};
//# sourceMappingURL=renderer-angular.js.map