import type { Demo } from '@knapsack/types';
import type { RendererMetaBase } from '@knapsack/renderer-webpack-base';
export declare const rendererMetaScriptTagId = "ks-angular-meta";
export type ExtraImportNames = 'CustomNgModule' | 'WrapperComponent';
/**
 * Found as JSON in HTML `#ks-angular-meta`
 * @see {rendererMetaScriptTagId}
 */
export type KsAngularMeta = {
    demo: Demo;
    template: string;
    hasWrapper: boolean;
} & RendererMetaBase;
/**
 * https://angular.io/guide/workspace-config
 */
export type NgJson = {
    projects: Record<string, {
        root: string;
        sourceRoot: string;
        architect: {
            build: {
                options: {
                    outputPath: string | {
                        base: string;
                        browser: string;
                    };
                };
            };
        };
    }>;
};
//# sourceMappingURL=types.d.ts.map