import { defineConfig } from 'vitest/config';

// https://vitest.dev/config/
export default defineConfig({
  test: {
    // Include both .ts and .mts files for tests
    include: ['src/**/*.{vtest,vitest}.{ts,tsx,mts,mtsx}'],
    includeSource: ['src/**/*.{ts,tsx,mts,mtsx}'],
    setupFiles: ['./vitest.setup.mts'],
    coverage: {
      enabled: true,
      reporter: ['text'],
      include: ['src/**/*.{ts,tsx,mts,mtsx}'],
      exclude: ['./src/test-fixtures/**', './src/index.ts'],
    },
  },
});
